<?php 
class ControllerPaymentSlydepay extends Controller {
	private $error = array(); 

	public function index() {
		$this->load->language('payment/slydepay');

		//$this->document->title = $this->language->get('heading_title');
		
		$this->load->model('setting/setting');
			
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->load->model('setting/setting');
			
			$this->model_setting_setting->editSetting('slydepay', $this->request->post);				
			
			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect(HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token']);
		}

		$data['heading_title'] = $this->language->get('heading_title');
		
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		
		$data['entry_APIVersion'] = $this->language->get('entry_APIVersion');
		$data['entry_MerchantKey'] = $this->language->get('entry_MerchantKey');		
		$data['entry_MerchantEmail'] = $this->language->get('entry_MerchantEmail');
		$data['entry_callback'] = $this->language->get('entry_callback');
		$data['entry_UseIntMode'] = $this->language->get('entry_UseIntMode');
		$data['entry_order_status'] = $this->language->get('entry_order_status');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$data['help_APIVersion'] = $this->language->get('help_APIVersion');
		$data['help_MerchantKey'] = $this->language->get('help_MerchantKey');
		$data['help_MerchantEmail'] = $this->language->get('help_MerchantEmail');
		$data['help_callback'] = $this->language->get('help_callback');
		$data['help_UseIntMode'] = $this->language->get('help_UseIntMode');
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['tab_general'] = $this->language->get('tab_general');

 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

 		if (isset($this->error['slydepay_APIVersion'])) {
			$data['error_slydepay_APIVersion'] = $this->error['slydepay_APIVersion'];
		} else {
			$data['error_slydepay_APIVersion'] = '';
		}
		if (isset($this->error['slydepay_MerchantKey'])) {
			$data['error_slydepay_MerchantKey'] = $this->error['slydepay_MerchantKey'];
		} else {
			$data['error_slydepay_MerchantKey'] = '';
		}
		if (isset($this->error['slydepay_MerchantEmail'])) {
			$data['error_slydepay_MerchantEmail'] = $this->error['slydepay_MerchantEmail'];
		} else {
			$data['error_slydepay_MerchantEmail'] = '';
		}
		
  		$data['breadcrumbs'] = array();

   		$data['breadcrumbs'][] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$data['breadcrumbs'][] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_payment'),
      		'separator' => ' :: '
   		);

   		$data['breadcrumbs'][] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=payment/slydepay&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
				
		$data['action'] = HTTPS_SERVER . 'index.php?route=payment/slydepay&token=' . $this->session->data['token'];
		
		$data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'];
		
		if (isset($this->request->post['slydepay_APIVersion'])) {
			$data['slydepay_APIVersion'] = $this->request->post['slydepay_APIVersion'];
		} else {
			$data['slydepay_APIVersion'] = $this->config->get('slydepay_APIVersion');
		}
		
		if (isset($this->request->post['slydepay_MerchantKey'])) {
			$data['slydepay_MerchantKey'] = $this->request->post['slydepay_MerchantKey'];
		} else {
			$data['slydepay_MerchantKey'] = $this->config->get('slydepay_MerchantKey');
		}
		
		if (isset($this->request->post['slydepay_MerchantEmail'])) {
			$data['slydepay_MerchantEmail'] = $this->request->post['slydepay_MerchantEmail'];
		} else {
			$data['slydepay_MerchantEmail'] = $this->config->get('slydepay_MerchantEmail');
		}
		
		$data['callback'] = HTTP_CATALOG . 'index.php?route=payment/slydepay/callback';
		
		if (isset($this->request->post['slydepay_UseIntMode'])) {
			$data['slydepay_UseIntMode'] = $this->request->post['slydepay_UseIntMode'];
		} else {
			$data['slydepay_UseIntMode'] = $this->config->get('slydepay_UseIntMode');
		} 
		
		if (isset($this->request->post['slydepay_order_status_id'])) {
			$data['slydepay_order_status_id'] = $this->request->post['slydepay_order_status_id'];
		} else {
			$data['slydepay_order_status_id'] = $this->config->get('slydepay_order_status_id'); 
		}
		
		$this->load->model('localisation/order_status');
		
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		
		if (isset($this->request->post['slydepay_status'])) {
			$data['slydepay_status'] = $this->request->post['slydepay_status'];
		} else {
			$data['slydepay_status'] = $this->config->get('slydepay_status');
		}
		
		if (isset($this->request->post['slydepay_sort_order'])) {
			$data['slydepay_sort_order'] = $this->request->post['slydepay_sort_order'];
		} else {
			$data['slydepay_sort_order'] = $this->config->get('slydepay_sort_order');
		}
	
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('payment/slydepay.tpl', $data));
		
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/slydepay')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->request->post['slydepay_APIVersion']) {
			$this->error['slydepay_APIVersion'] = $this->language->get('error_APIVersion');
		}
		
		if (!$this->request->post['slydepay_MerchantKey']) {
			$this->error['slydepay_MerchantKey'] = $this->language->get('error_MerchantKey');
		}
		
		if (!$this->request->post['slydepay_MerchantEmail']) {
			$this->error['slydepay_MerchantEmail'] = $this->language->get('error_MerchantEmail');
		}
		
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
}
?>